diff --git a/job.cpp b/job.cpp
index 6361e7c..defae70 100644
--- a/job.cpp
+++ b/job.cpp
@@ -351,11 +351,13 @@ JobThread::JobThread(const wxString &jid)
 	jobid = jid;
 
 	DBconn *threadConn = DBconn::Get(DBconn::GetBasicConnectString(), serviceDBname);
-	job = new Job(threadConn, jobid);
-
-	if (job->Runnable())
-		runnable = true;
+	if (threadConn)
+	{
+		job = new Job(threadConn, jobid);
 
+		if (job->Runnable())
+			runnable = true;
+	}
 }
 
 
diff --git a/pgAgent.cpp b/pgAgent.cpp
index ce15e08..2872a75 100644
--- a/pgAgent.cpp
+++ b/pgAgent.cpp
@@ -109,6 +109,11 @@ int MainRestartLoop(DBconn *serviceConn)
 					jt->Run();
 					foundJobToExecute = true;
 				}
+				else
+				{
+					// A thread object that's started will destroy itself when it's finished, but one that never starts we'll have to destory ourselves.
+					delete jt;
+				}
 				res->MoveNext();
 
 			}
